## libssw 1.0

=== src/Makefile ===
CC = gcc
CXX = g++
CFLAGS := -Wall -pipe -O3
CXXFLAGS := $(CFLAGS)
LOBJS = ssw.o
LCPPOBJS = ssw_cpp.o
PROG = ssw_test
LIB = libssw.so
EXAMPLE = example_c
EXAMPLE_CPP = example_cpp
JAVA_JAR = ssw.jar
JAVA_LIB = libsswjni.so
JAVA_INLCUDES = -I"$(JAVA_HOME)/include" -I"$(JAVA_HOME)/include/linux"
JAVA_OBJ = ssw/Aligner.class ssw/Alignment.class ssw/Example.class

.PHONY: all default java clean

default: $(PROG) $(EXAMPLE) $(EXAMPLE_CPP) $(LIB) 

all: default java

java: $(JAVA_JAR) $(JAVA_LIB)

$(LIB): ssw.c ssw.h
	$(CC) $(CFLAGS) -fPIC -shared -rdynamic -o $@ $<

$(PROG): main.c kseq.h

$(EXAMPLE): example.c

$(PROG) $(EXAMPLE): $(LOBJS)
	$(CC) -o $@ $(filter-out %.h,$^) $(CFLAGS) -lm -lz

$(EXAMPLE_CPP): example.cpp $(LOBJS) $(LCPPOBJS)
	$(CXX) -o $@ $^ $(CXXFLAGS) -lm -lz

$(JAVA_LIB): sswjni.c ssw.c ssw.h
	$(CC) $(CFLAGS) $(JAVA_INLCUDES) -fPIC -shared -rdynamic -o $@ $< ssw.c 

$(JAVA_JAR): $(JAVA_OBJ)
	jar cvfe $@ ssw.Example $^

%.class: %.java
	javac -cp ./ $<
	
ssw.o: ssw.c ssw.h
	$(CC) -c -o $@ $< $(CFLAGS)

ssw_cpp.o: ssw_cpp.cpp ssw_cpp.h ssw.h
	$(CXX) -c -o $@ $< $(CXXFLAGS)

clean:
	-rm -f $(LOBJS) $(LCPPOBJS) $(PROG) $(LIB) $(EXAMPLE) $(EXAMPLE_CPP) $(JAVA_LIB) $(JAVA_JAR) $(JAVA_OBJ) *~

=== debian/changelog ===
libssw (1.0-2) unstable; urgency=medium

  * adjust list of architectures to only include SSE2 capable ones
    Closes: #828209

 -- Sascha Steinbiss <satta@debian.org>  Sun, 26 Jun 2016 16:46:41 +0000

libssw (1.0-1) unstable; urgency=medium

  * Initial release. (Closes: #828042)

 -- Sascha Steinbiss <satta@debian.org>  Fri, 24 Jun 2016 13:45:35 +0000

=== debian/control ===
Source: libssw
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sascha Steinbiss <satta@debian.org>
Build-Depends: debhelper (>= 9),
               default-jdk-headless,
               javahelper,
               dh-autoreconf,
               help2man,
               zlib1g-dev
Standards-Version: 3.9.8
Testsuite: autopkgtest
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libssw.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/libssw.git
Homepage: https://github.com/mengyao/Complete-Striped-Smith-Waterman-Library

Package: libssw0
Architecture: any-amd64 any-x32
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         zlib1g
Pre-Depends: ${misc:Pre-Depends}
Description: fast SIMD parallelized implementation of the Smith-Waterman algorithm
 SSW is a fast implementation of the Smith-Waterman algorithm, which uses the
 Single-Instruction Multiple-Data (SIMD) instructions to parallelize the
 algorithm at the instruction level. SSW library provides an API that can be
 flexibly used by programs written in C, C++ and other languages. The library
 can do protein and genome alignment directly.
 Current version of this implementation is ~50 times faster than an ordinary
 Smith-Waterman. It can return the Smith-Waterman score, alignment location
 and traceback path (cigar) of the optimal alignment accurately; and return
 the sub-optimal alignment score and location heuristically.

Package: libssw-dev
Provides: libssw-dev
Architecture: any-amd64 any-x32
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libssw0 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Description: Development headers and static libraries for libssw
 This package provides development headers and static libraries for libssw,
 a fast implementation of the Smith-Waterman algorithm using
 Single-Instruction Multiple-Data (SIMD) instructions to parallelize the
 algorithm at the instruction level.

Package: libssw-java
Architecture: any-amd64 any-x32
Section: java
Depends: ${java:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: ${java:Recommends}
Description: Java bindings for libssw
 This package provides JNI based Java bindings for libssw, a fast
 implementation of the Smith-Waterman algorithm using Single-Instruction
 Multiple-Data (SIMD) instructions to parallelize the algorithm at the
 instruction level.

Package: ssw-align
Architecture: any-amd64 any-x32
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libssw0 (= ${binary:Version})
Description: Smith-Waterman aligner based on libssw
 This package provides a command-line aligner based on the libssw library,
 a fast SIMD accelerated implementation of the Smith-Waterman algorithm.
 The input files can be in FASTA or FASTQ format. Both target and query files
 can contain multiple sequences. Each sequence in the query file will be
 aligned with all sequences in the target file. Output is provided in SAM or
 BLAST-like text format.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
DEBVERS := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
PKG_VERSION := $(shell echo '$(DEBVERS)' | sed -e 's/^[[:digit:]]*://' -e 's/-.*//')

%:
	dh $@

override_dh_auto_clean:
	rm -f debian/libssw*install debian/libssw*links debian/ssw-align.1
	$(MAKE) -C src clean

override_dh_auto_build:
	$(MAKE) -C src default java

override_dh_auto_install: debian/libssw0.install debian/libssw-dev.install debian/libssw-dev.links debian/libssw-java.install debian/libssw-java.links
	mv src/ssw.jar src/ssw-$(PKG_VERSION).jar
	dh_auto_install

override_dh_installman:
	LD_LIBRARY_PATH=`pwd`/src help2man --version-string=' ' --help-option=' ' \
          -I debian/extra-man-info.txt \
          -N -n 'fast Smith-Waterman aligner' \
          --no-discard-stderr src/ssw-align \
            | fgrep -v ERROR > debian/ssw-align.1
	dh_installman

override_dh_auto_test:
	src/example_c
	src/example_cpp

debian/%.install: debian/%.install.in
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' $< > $@

debian/%.links: debian/%.links.in
	sed -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
            -e 's/@DEB_JAVA_PKG_VERSION@/$(PKG_VERSION)/g' $< > $@

## libssw 1.1

=== src/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 CC = gcc
 CXX = g++
-CFLAGS := -Wall -pipe -O3
+CFLAGS := -Wall -pipe -O2
 CXXFLAGS := $(CFLAGS)
 LOBJS = ssw.o
 LCPPOBJS = ssw_cpp.o

=== debian/changelog ===
libssw (1.1-2) unstable; urgency=medium

  * Team upload.
  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5
  * d/rules:
     - Respect DEB_BUILD_OPTIONS in override_dh_auto_test
     - Do not parse d/changelog

 -- Andreas Tille <tille@debian.org>  Mon, 16 Jul 2018 10:11:08 +0200

libssw (1.1-1) unstable; urgency=medium

  [ Sascha Steinbiss ]
  * New upstream release.
  * Change 'any-x32' to 'x32' -- there is only one x32 arch.
    Silences Lintian warning.

  [ Afif Elghraoui ]
  * Bump minimum required debhelper version

 -- Sascha Steinbiss <satta@debian.org>  Mon, 22 Aug 2016 18:06:10 +0000

libssw (1.0-3) unstable; urgency=medium

  * Team upload
  * Install maven-repo artifacts.
    - Build-depend on maven-repo-helper
    - Add debian/libssw-java-1.0.pom and debian/libssw-java.poms
    - Update debian/rules to build with jh_maven_repo_helper

 -- tony mancill <tmancill@debian.org>  Sun, 10 Jul 2016 21:07:21 -0700

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,21 @@
 Source: libssw
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Uploaders: Sascha Steinbiss <satta@debian.org>
 Section: science
 Priority: optional
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Sascha Steinbiss <satta@debian.org>
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11~),
                default-jdk-headless,
                javahelper,
-               dh-autoreconf,
                help2man,
-               zlib1g-dev
-Standards-Version: 3.9.8
-Testsuite: autopkgtest
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/libssw.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/libssw.git
+               zlib1g-dev,
+               maven-repo-helper
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/med-team/libssw
+Vcs-Git: https://salsa.debian.org/med-team/libssw.git
 Homepage: https://github.com/mengyao/Complete-Striped-Smith-Waterman-Library
 
 Package: libssw0
-Architecture: any-amd64 any-x32
+Architecture: any-amd64 x32
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
@@ -35,14 +34,14 @@
  the sub-optimal alignment score and location heuristically.
 
 Package: libssw-dev
-Provides: libssw-dev
-Architecture: any-amd64 any-x32
+Architecture: any-amd64 x32
 Multi-Arch: same
 Section: libdevel
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          libssw0 (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
+Provides: libssw-dev
 Description: Development headers and static libraries for libssw
  This package provides development headers and static libraries for libssw,
  a fast implementation of the Smith-Waterman algorithm using
@@ -50,7 +49,7 @@
  algorithm at the instruction level.
 
 Package: libssw-java
-Architecture: any-amd64 any-x32
+Architecture: any-amd64 x32
 Section: java
 Depends: ${java:Depends},
          ${shlibs:Depends},
@@ -63,7 +62,7 @@
  instruction level.
 
 Package: ssw-align
-Architecture: any-amd64 any-x32
+Architecture: any-amd64 x32
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          libssw0 (= ${binary:Version})

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

include /usr/share/dpkg/default.mk

%:
	dh $@ --with javahelper --with jh_maven_repo_helper

override_dh_auto_clean:
	rm -f debian/libssw*install debian/libssw*links debian/ssw-align.1
	$(MAKE) -C src clean

override_dh_auto_build:
	$(MAKE) -C src default java

override_dh_auto_install: debian/libssw0.install debian/libssw-dev.install debian/libssw-dev.links debian/libssw-java.install debian/libssw-java.links
	mv src/ssw.jar src/ssw-$(DEB_VERSION_UPSTREAM).jar
	dh_auto_install

override_dh_installman:
	LD_LIBRARY_PATH=`pwd`/src help2man --version-string=' ' --help-option=' ' \
          -I debian/extra-man-info.txt \
          -N -n 'fast Smith-Waterman aligner' \
          --no-discard-stderr src/ssw-align \
            | fgrep -v ERROR > debian/ssw-align.1
	dh_installman

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	src/example_c
	src/example_cpp
endif

debian/%.install: debian/%.install.in
	sed 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' $< > $@

debian/%.links: debian/%.links.in
	sed -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
            -e 's/@DEB_JAVA_PKG_VERSION@/$(DEB_VERSION_UPSTREAM)/g' $< > $@

=== debian/watch ===
version=3
https://github.com/mengyao/Complete-Striped-Smith-Waterman-Library/tags .*/v?(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))

## libssw 1.2.5

=== src/Makefile ===
CC = gcc
CXX = g++
CFLAGS += -Wall -pipe -O2
#CFLAGS += -Wall -pipe -g -fsanitize=address	# for debug
CXXFLAGS := $(CFLAGS)
LOBJS = ssw.o
LCPPOBJS = ssw_cpp.o
PROG = ssw_test
LIB = libssw.so
EXAMPLE = example_c
EXAMPLE_CPP = example_cpp
JAVA_JAR = ssw.jar
JAVA_LIB = libsswjni.so
JAVA_INLCUDES = -I$(JAVA_HOME)/include -I$(JAVA_HOME)/include/linux
JAVA_OBJ = ssw/Aligner.class ssw/Alignment.class ssw/Example.class

.PHONY: all default java clean

default: $(PROG) $(EXAMPLE) $(EXAMPLE_CPP) $(LIB) 
core: $(PROG)
java: java_home $(JAVA_JAR) $(JAVA_LIB)
all: default java

$(LIB): ssw.c ssw.h
	$(CC) $(CFLAGS) -fPIC -shared -rdynamic -o $@ $<

$(PROG): main.c kseq.h

$(EXAMPLE): example.c

ifdef __arm__ # (M1)
$(PROG) $(EXAMPLE): $(LOBJS)
	$(CC) -o $@ $(filter-out %.h,$^) $(CFLAGS) $(LDFLAGS) -lm -lz -march=armv8-a+fp+simd+crypto+crc
else # x86(Intel)
$(PROG) $(EXAMPLE): $(LOBJS)
	$(CC) -o $@ $(filter-out %.h,$^) $(CFLAGS) $(LDFLAGS) -lm -lz
endif

$(EXAMPLE_CPP): example.cpp $(LOBJS) $(LCPPOBJS)
	$(CXX) -o $@ $^ $(CXXFLAGS) $(LDFLAGS) -lm -lz

$(JAVA_LIB): sswjni.c ssw.c ssw.h
	$(CC) $(CFLAGS) $(JAVA_INLCUDES) -fPIC -shared -rdynamic -o $@ $< ssw.c 

$(JAVA_JAR): $(JAVA_OBJ)
	jar cvfe $@ ssw.Example $^

%.class: %.java
	javac -cp ./ $<

java_home:
ifndef JAVA_HOME
	@$(ECHO) "ERROR: Your JAVA_HOME environment variable is not set."
	exit 1
endif

ssw.o: ssw.c ssw.h
	$(CC) -c -o $@ $< $(CFLAGS)

ssw_cpp.o: ssw_cpp.cpp ssw_cpp.h ssw.h
	$(CXX) -c -o $@ $< $(CXXFLAGS)

clean:
	-rm -f $(LOBJS) $(LCPPOBJS) $(PROG) $(LIB) $(EXAMPLE) $(EXAMPLE_CPP) $(JAVA_LIB) $(JAVA_JAR) $(JAVA_OBJ) *~

=== debian/changelog ===
libssw (1.2.5-1) experimental; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * New upstream version.
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Update symbols for gcc-13
    Closes: #1037742

  [ Michael R. Crusoe ]
  * Remove extra copy of SIMDe in debian/include/simde

 -- Andreas Tille <tille@debian.org>  Sat, 15 Jul 2023 12:56:57 +0200

libssw (1.2.4-1) experimental; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Set JAVA_HOME explicitly
  * Upstream API has changed thus bump SONAME
  * Add missing BSD-2-clause license

 -- Andreas Tille <tille@debian.org>  Thu, 26 May 2022 07:49:04 +0200

libssw (1.1-13) unstable; urgency=medium

  * Do not hardcode source/target version levels into javac call.
    Closes: #982045
  * Bump Standards-Version.
  * Use watchfile version 4.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 20 Feb 2021 21:21:08 +0100

libssw (1.1-12) unstable; urgency=medium

  * Mark one symbol as optional, disappearing on s390x with -O3
    optimization level (Closes: #980181)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 15 Jan 2021 19:29:58 +0100

libssw (1.1-11) unstable; urgency=medium

  * Team upload
  * Make sure library will be build before it is used for linking
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 13 Aug 2020 13:42:07 +0200

libssw (1.1-10) unstable; urgency=medium

  * Team upload

  [ Michael R. Crusoe ]
  * Improve crossbuilding
  * Add "nojava" build profile
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Andreas Tille ]
  * Drop symbol from symbols file that is not created by gcc-10
    Closes: #957481

 -- Andreas Tille <tille@debian.org>  Thu, 23 Jul 2020 10:44:14 +0200

libssw (1.1-9) unstable; urgency=medium

  * debian/include/simde: sync with upstream 2020-02-15
    More big endian fixes: 35f048529bd7b0efa2ed3a83866ea2a1d35c25f2

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 16 Feb 2020 16:11:29 +0100

libssw (1.1-8) unstable; urgency=medium

  * Standards-Version: 4.5.0 (routine-update)
  * debian/include/simde: sync with upstream 2020-02-14
    (59b6a740ef7c1955c49408c22976f21e1d1dd27c)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 15 Feb 2020 16:51:22 +0100

libssw (1.1-7) unstable; urgency=medium

  * debian/patches/malloc: Include definition for malloc & free
  * debian/include/simde: sync with upstream 2019-12-27
    (098d150385ba618f945f953bc4d5ae306fd22f2e)
  * debian/libssw0.symbols: start tracking the library symbols

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 26 Dec 2019 16:59:08 +0100

libssw (1.1-6) unstable; urgency=medium

  * Release to unstable.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Dec 2019 13:24:05 +0100

libssw (1.1-6~0expsimde2) experimental; urgency=medium

  * Fix some simde c/c++ compat

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Dec 2019 12:11:05 +0100

libssw (1.1-6~0expsimde1) experimental; urgency=medium

  * Include patch from upstream SIMDE for SH4

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Dec 2019 08:12:10 +0100

libssw (1.1-6~0expsimde0) experimental; urgency=medium

  * Enable for all architectures using simde
  * Add myself as an uploader

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 11 Dec 2019 15:14:03 +0100

libssw (1.1-4) unstable; urgency=medium

  * Source upload to enable testing migration.
  * Switch to debhelper-compat.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 20 Nov 2019 11:06:19 +0100

libssw (1.1-3) unstable; urgency=medium

  * Enable building on ppc64el.
    Thanks to Frédéric Bonnard for the patch.
    Closes: #942517
  * Use debhelper 12.
  * Bump Stadards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Sun, 27 Oct 2019 22:51:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,24 @@
 Source: libssw
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Sascha Steinbiss <satta@debian.org>
+Uploaders: Sascha Steinbiss <satta@debian.org>,
+           Michael R. Crusoe <crusoe@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11~),
-               default-jdk-headless,
-               javahelper,
+Build-Depends: debhelper-compat (= 13),
+               default-jdk-headless <!nojava>,
+               javahelper <!nojava>,
                help2man,
                zlib1g-dev,
-               maven-repo-helper
-Standards-Version: 4.1.5
+               libsimde-dev,
+               maven-repo-helper <!nojava>
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/libssw
 Vcs-Git: https://salsa.debian.org/med-team/libssw.git
 Homepage: https://github.com/mengyao/Complete-Striped-Smith-Waterman-Library
+Rules-Requires-Root: no
 
-Package: libssw0
-Architecture: any-amd64 x32
+Package: libssw1
+Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends},
@@ -34,12 +37,11 @@
  the sub-optimal alignment score and location heuristically.
 
 Package: libssw-dev
-Architecture: any-amd64 x32
+Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         libssw0 (= ${binary:Version})
+Depends: ${misc:Depends},
+         libssw1 (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
 Provides: libssw-dev
 Description: Development headers and static libraries for libssw
@@ -49,7 +51,8 @@
  algorithm at the instruction level.
 
 Package: libssw-java
-Architecture: any-amd64 x32
+Build-Profiles: <!nojava>
+Architecture: any
 Section: java
 Depends: ${java:Depends},
          ${shlibs:Depends},
@@ -62,10 +65,10 @@
  instruction level.
 
 Package: ssw-align
-Architecture: any-amd64 x32
+Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         libssw0 (= ${binary:Version})
+         libssw1 (= ${binary:Version})
 Description: Smith-Waterman aligner based on libssw
  This package provides a command-line aligner based on the libssw library,
  a fast SIMD accelerated implementation of the Smith-Waterman algorithm.

=== debian/rules ===
--- 
+++ 
@@ -2,22 +2,45 @@
 
 # DH_VERBOSE := 1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+export DEB_CFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
+export DEB_CXXFLAGS_MAINT_APPEND += -DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3
+
+ifeq ($(DEB_BUILD_ARCH), ppc64el)
+export DEB_CFLAGS_MAINT_APPEND = -DNO_WARN_X86_INTRINSICS
+export DEB_CXXFLAGS_MAINT_APPEND = -DNO_WARN_X86_INTRINSICS
+endif
+
+export JAVA_HOME=/usr/lib/jvm/default-java
 
 include /usr/share/dpkg/default.mk
 
+ifneq ($(filter nojava,$(DEB_BUILD_PROFILES)),)
+%:
+	dh $@
+else
 %:
 	dh $@ --with javahelper --with jh_maven_repo_helper
+endif
 
 override_dh_auto_clean:
 	rm -f debian/libssw*install debian/libssw*links debian/ssw-align.1
-	$(MAKE) -C src clean
+	dh_auto_clean --sourcedirectory src
 
 override_dh_auto_build:
-	$(MAKE) -C src default java
+ifneq ($(filter nojava,$(DEB_BUILD_PROFILES)),)
+	dh_auto_build --sourcedirectory src -- default
+else
+	dh_auto_build --sourcedirectory src -- default java
+endif
 
-override_dh_auto_install: debian/libssw0.install debian/libssw-dev.install debian/libssw-dev.links debian/libssw-java.install debian/libssw-java.links
+ifneq ($(filter nojava,$(DEB_BUILD_PROFILES)),)
+override_dh_auto_install: debian/libssw1.install debian/libssw-dev.install debian/libssw-dev.links
+	dh_auto_install
+else
+override_dh_auto_install: debian/libssw1.install debian/libssw-dev.install debian/libssw-dev.links debian/libssw-java.install debian/libssw-java.links
 	mv src/ssw.jar src/ssw-$(DEB_VERSION_UPSTREAM).jar
 	dh_auto_install
+endif
 
 override_dh_installman:
 	LD_LIBRARY_PATH=`pwd`/src help2man --version-string=' ' --help-option=' ' \
@@ -29,8 +52,7 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	src/example_c
-	src/example_cpp
+	LD_PRELOAD="$$LD_PRELOAD $(CURDIR)/src/libssw.so" src/ssw-align -c demo/ref.fa demo/1k.fa
 endif
 
 debian/%.install: debian/%.install.in

=== debian/tests/control ===
Tests: build-lib
Depends: libssw0, libssw-dev, build-essential, zlib1g-dev

Tests: build-lib-java
Depends: libssw-java, default-jdk-headless

Tests: run-example
Depends: ssw-align
Restrictions: allow-stderr
